------------------------
v1.06 [2014-11-26]
------------------------
* Added: Basic offline play. (connecting to local server without logging in)
* Added: Loading screen. (except on OS X)
* Added: Subdirectory support for various user data.
* Added: Editor top menu.
* Added: Editor map resize functionality.
* Added: Map script example: Tile Basics
* Added: Map script example: Moving Tiles
* Added: Map script example: Tile Text
* Added: Map script example: Projectiles & Grenades
* Added: Map: Pile of Sand
* Added: Map: Chairs
* Added: Music Track: Nice Time Winning
* Added: New Lua bindings for kfyMap.
* Added: New Lua bindings for kfyRound.
* Added: New Lua bindings for kfyPlayerManager.
* Added: New Lua bindings for kfyProjectileManager.
* Added: New Lua bindings for kfyGrenadeManager.
* Added: New Lua bindings for KfyPlayer.
* Added: New Lua bindings for KfyProjectile.
* Added: New Lua bindings for KfyGrenade.
* Added: Client command-line argument: --editor
* Added: Client command-line argument: --create-map
* Added: Client command-line argument: --edit-map [filename]
* Added: Client command-line argument: --play-offline
* Added: Client command: respawn
* Added: Client command: moveto [x] [y]
* Added: Client command: movetomouse
* Added: Client command: god
* Added: Client command: getweapon [id]
* Added: Client command: getitem [id]
* Added: Client command: getpu [id]
* Added: Client command: setpubit [id] [1/0]
* Added: Client command: getblocks [count=16] [tx=1] [ty=0] [destructible=1]
* Added: Client/server command: restartmap
* Added: Client/server command: reloadmaplist
* Added: Client/server command: reloadmap [filename]
* Added: Client/server command: reloadmaps
* Added: Client settings variable: ShowPlayerNames
* Added: Client settings variable: ChatToConsole
* Added: Client settings variable: LogToStdOut
* Added: Client settings variable: LinuxServerTerminalCmd
* Added: Client settings variable: BkgGradientColorIn
* Added: Client settings variable: BkgGradientColorOut
* Added: Client settings variable: BkgGradientNoise
* Added: Client settings variable: GuiLabelColor
* Added: Client settings variable: GuiLabelColorShadow
* Added: Client settings variable: GuiButtonColor
* Added: Client settings variable: GuiButtonColorSelected
* Added: Client settings variable: GuiButtonColorText
* Added: Client settings variable: GuiButtonColorTextSelected
* Added: Client settings variable: GuiCheckBoxColor
* Added: Client settings variable: GuiCheckBoxColorBorder
* Added: Client settings variable: GuiCheckBoxColorSelected
* Changed: Merged client and editor applications.
* Changed: Max map dimension to 2000 tiles.
* Changed: Editor screen rectangle now scrolls half a screen past border of maps.
* Changed: Editor screen rectangle now centers on map center on load.
* Changed: Editor minimap scaling is now more flexible.
* Changed: Editor minimap selection overlay is no longer visible when map is smaller than screen.
* Changed: Various shader changes and added some better blur + noise to reduce banding artifacts.
* Changed: Removed fade-to-black on exit from server to get back to menu/lobby quicker.
* Changed: Lowered Fredrik stun duration.
* Changed: Increased rate of fire for Infernus and made its projectiles ignite players on impact.
* Fixed: Electrooms can no longer do 5 additional damage.
* Fixed: Minimap refresh on undo/redo in editor.
* Fixed: Config files can no longer have entries with empty names.
* Fixed: Billy blood direction.
* Fixed: Projectile penetration.
* Fixed: Spreading fire now creates new sound sources correctly.
* Fixed: Connecting players can now hear burning sound of players who are already ablaze.
* Fixed: Single weapon sounds can no longer be heard after death.
* Fixed: Team scores now always show up correctly upon joining a new server.
* Fixed: Editor minimap no longer detects mouse movement if it wasn't under the mouse cursor on click.
* Fixed: Missing config files are now recreated correctly.
* Fixed: kfyMap:tileGetBounds now works as intended.
* Fixed: Graphic glitch that could occur when exiting settings screen.
* Fixed: Screen rectangle is now always set up correctly when joining a server.
* Fixed: Some problems with mouse activity outside of game window.
* Fixed: Players no longer appear to be falling briefly when spawning on solid ground.
* Fixed: Local player spawn flash sprite now has correct orientation close to map edges.

------------------------
v1.05 [2014-08-04]
------------------------
* Added client side prediction for local player movement.
* Added new graphics for various explosions.
* Added new sound effect for Valkondis detonation.
* Added VSync checkbox to the settings screen.
* Added client settings variable: FpsMax (default = 300)
* Changed (lowered) default value for PlayerPositionSendInterval to 15 in ServerConfig.cfg.
* Changed (removed) recoil for Besco and Infernus.
* Changed a lot of netcode.

------------------------
v1.04 [2014-07-09]
------------------------
* Added basic scripting support for maps, using Lua, allowing for more dynamic tile behaviour and more. Further information is available in Documentation/Lua.txt.
* Added visual overlay for damaged tiles.
* Added music track: Korvspad
* Added music track: Prutt's Night Out
* Added client command: addvar
* Added client command: reloadmapscript
* Added client command: clearbans
* Added server command: reloadmapscript
* Added server command: clearbans
* Added client/editor variables for GUI color values.
* Added client variable: DebugShowPlayerPos
* Added client variable: DebugShowPlayerServerPos
* Added client variable: DebugShowMapOverlay
* Added ability to change tile in tileset with numpad keys in the editor app.
* Added ability to sample tileset coords with MMB in the editor app.
* Changed so that the look direction of the local player is updated locally.
* Changed so that ladders are always considered to be part of the middle layer.
* Changed (increased) player base acceleration.
* Fixed a lot of issues with integrated Intel GPUs on Windows.
* Fixed a bug that could cause lag when transferring files to the client with large files or low bandwidth.
* Fixed a bug where the key bindings window could become displaced after switching screen resolution.
* Fixed a bug where the look direction of a player could be incorrect when mouse cursor was outside of the game window.
* Fixed a bug where the screen rectangle would not be reset properly on respawn.
* Fixed a bug that made it easy to accidentally draw tiles after closing a GUI window in the editor app.

------------------------
v1.03 [2014-06-15]
------------------------
* Added music track: Atlas Anthem
* Added client resolution: 1920x1200
* Added compression for map tiles.
* Added mouse wheel support for the in-game chat box and the game console.
* Added key bindings for toggling and navigating the game console.
* Added key bindings for custom (12) custom macros.
* Added key binding for Build Mode (hold).
* Added ability to execute multiple commands in sequence by using ';' as a delimiter.
* Added client command: showconsole
* Added client command: hideconsole
* Added client command: quack
* Added server settings variable: PlayerSpawnProtectDuration (default = 5.0)
* Added server settings variable: PlayerStartHealth (default = 100)
* Added server settings variable: PlayerStartSauce (default = 100)
* Added server settings variable: ChatSpamProtect (default = TRUE)
* Added server settings variable: ChatSpamProtectCount (default = 4)
* Added server settings variable: ChatSpamProtectDuration (default = 2.0)
* Added server settings variable: ChatSpamProtectMuteDuration (default = 6.0)
* Changed so that there is a delay for switching teams and a player is killed if it is already spawned.
* Changed so that the offset for the in-game chat box is only reset on new messages if it is already at the bottom.
* Changed the way various GUI elements are drawn.
* Changed so that debug output is not added to the message feed.
* Changed so that the game console always covers the entire screen.
* Changed so that initiating a stomp does not remove spawn protection.
* Fixed a bug that counted time spectating as time alive.
* Fixed a bug that could render the client app unresponsive after a failed/interrupted connection attempt.
* Fixed a bug that prevented tiles to be places on F spawners in non-CTF games.
* Fixed a bug that would sometimes start the client round timer with an incorrect time value.
* Fixed various minor graphical glitches in the editor app.

------------------------
v1.02 [2014-05-26]
------------------------
* Added ability to browse previously sent console commands using the arrow keys.
* Added client command: say
* Added client command: tsay
* Added client settings variable: WindowsCrashDump (default = TRUE)
* Changed so that all console input is treated as commands by default.
* Changed so that a player does not show as typing to others while entering console commands.
* Changed game server output to be less cluttered.
* Fixed a bug that could cause the lobby chat box to stay selected if activated right before entering a game server.
* Fixed a GUI-related bug that could cause the client to crash under some circumstances.
* Fixed a bug that could cause problems on removal of players on disconnect.

------------------------
v1.01 [2014-05-22]
------------------------
* Added more resolutions up to 1920x1080 for the game client.
* Added client command: reloadvars
* Added client command: listvars
* Added client command: getvar [name]
* Added client command: setvar [name] [value]
* Added client settings variable: HideSpectateOverlay (default = FALSE)
* Added client/editor settings variable: MaxFeedLines (default = 5)
* Changed so that the mouse cursor is unlocked while viewing the ESC screen.
* Changed so that command list (help) is displayed in the console rather than in the chat box.
* Changed color alpha of the game console.
* Changed so that a player dies when becoming a spectator while spawned.
* Changed (removed) delay for placing tiles.
* Changed (lowered) delay for tapping tiles.
* Changed so that maps with smaller dimensions than the screen are centered.
* Fixed so that the Beta Hat does not flip.
* Fixed a bug where players would not get a response from game servers unable to authorize with the master server.
* Fixed a bug where game servers could stop trying to re-register with the master server after losing their connection.
* Fixed a bug that could make the music volume incorrect.
* Fixed so that the screen is properly being cleared when joining between rounds.
* Fixed end-of-round effect to look as it should when spectating.
* Fixed a bug that would prevent Wings of Flight from animating.
* Fixed a bug that could cause the player spawn flash effect to appear at multiple locations on the map at once.
* Fixed various bugs that would occur while editing a map with dimensions smaller than the screen resolution.
* Fixed so that the scoreboard always fits on the screen.

------------------------
v1.0 [2014-05-17]
------------------------
* Added full Linux build of the game (64 bit).
* Added the ability to set common key bindings in the Settings menu.
* Added more blood (default setting).
* Added the ability to set level of blood (or turn it off) in the Settings menu.
* Added additional sound effects for some of the gorier deaths.
* Added hat: Beta Hat
* Added colored borders to flag icons in the Editor application to make them more intuitive.
* Changed so that the Settings menu is available from within all game states.
* Changed the way tiles and particles are drawn to be less time consuming.
* Changed various things related to the GUI system to make it more responsive.
* Changed announcer sounds.
* Changed menu graphics.
* Changed so that no console messages are added on F pickup/drop to avoid possible deliberate spamming.
* Changed (lowered) the volume of some music tracks.
* Fixed a full screen effect that wasn't working properly on some AMD cards.
* Fixed a typo in a hat description.
* Fixed a bug where the player spawn flash effect would have an incorrect orientation.
* Fixed a bug that prevented certain empty particle systems from being destroyed.
* Fixed various bugs relating to players spectating.
* Fixed a bug that could make the game slow down when the console got flooded with a large number of messages.
* Fixed a bug where at some times players who had lost their connection would linger.
* Fixed a few broken URLs in the game client.

------------------------
Beta v0.40 [2013-06-12]
------------------------
* Added ability to spectate matches (accessible from the scoreboard).
* Added visual indicator for when a player is typing.
* Changed reload speed and stun duration for Zapper.
* Changed so that deflect explosions do no damage but have increased force and radius.
* Changed x-position for where billy rockets spawn.
* Fixed full screen effects that were problematic on some GPUs.
* Fixed a problem related to blood pixels making tiles flicker with OSX + Intel GPU.
* Fixed a minor particle system memory leak.
* Fixed a bug that would make it impossible to play certain music tracks at below 20% volume.

------------------------
Beta v0.39 [2012-11-24]
------------------------
* Added buttons for toggling sfx and music to the ESC-screen.
* Changed so that deflecting is done with LShift (by default) and attracting is done by simply right clicking.
* Fixed a bug that could lead to game servers crashing when kicking a player.
* Fixed a bug where players could throw grenades between rounds.
* Fixed problems with the game client freezing when CPU load is too high. (most likely only affected really bogged down and/or low end machines)
* Fixed a bug where certain game input would keep being processed between rounds.
* Fixed a bug that would make a player keep quacking repeatedly when holding the freeze button while out of sauce.
* Fixed so that the HUD never appears while the ESC-screen is showing.

------------------------
Beta v0.38 [2012-11-09]
------------------------
* Added a basic friend system and made various changes to the game lobby.
* Added the ability to freeze owned projectiles and grenades. (drains Awesome Sauce, default key = SPACE)
* Added the ability to bind chat messages or commands to the F-keys (F1 is reserved for toggling the console, see Settings/ClientSettings.cfg)
* Added player emote: /greet (bound to F2 by default)
* Added player emote: /cheer (bound to F3 by default)
* Added player emote: /dance (bound to F4 by default)
* Added player emote: /thefinger (bound to F5 by default)
* Added hat: Duck Face
* Added hat: Broken Top Hat
* Added hat: Golden Boot
* Added hat: Bratwurst
* Added hat: Pointy Helmet
* Added hat: Skull Pole
* Added hat: Skeleton Pole
* Added hat: Crown of Murderous Deeds
* Added hat: Dino Head
* Added hat: King of the Forest
* Added hat: Alpha Hat
* Added command line argument for the server application: -c [path to custom config file]
* Changed the max length of chat messages sent from game servers to clients to avoid things like long /maplist responses being cut off.
* Changed so that the KFY patcher and launcher applications will try alternate servers for downloads if the main one is not reachable.
* Fixed so that the Fiva Hat is not flipped when facing left.
* Fixed so that certain grenades does not move around when lying on the ground.

------------------------
Alpha v0.37 [2012-10-22]
------------------------
* Added one hat for each (damage dealing) weapon and grenade, that are awarded to players randomly when killing with the weapon/grenade in question.
* Added hats that are awarded for the larger kill streaks (10, 20).
* Added hats that are awarded for the larger multikills (4, 5, 6, 7).
* Added hats that are awarded to players that log in during certain holidays (Halloween & Christmas).
* Added a few personal hats for people who have contributed a lot to KFY (hosthazard, Danny, Dunder and KaLLe).
* Added item: Electroom (creates a powerful electric blast that stuns players and does some damage)
* Added powerup: Explonade Hiccup (ejects Explonades randomly)
* Added powerup: Unlimited Sauce (gives unlimited Awesome Sauce)
* Added a notification box for when a new hat is aquired (with the option of wearing it right away without having to leave the game).
* Added notification boxes for kick- and map votes.
* Changed so that only players of the opposite team of the owner of an Infroom blast can catch on fire from it (with the exception of the player throwing it) when friendly fire is on.
* Changed so that the Infroom burn effect can only be spread to those of the opposite team of the owner when friendly fire is off.
* Changed so that the Infroom burn effect has a shorter duration.
* Changed so that the Tryptanade effect does not reverse the movement keys and made the aim impairment worse.
* Changed so that the Fredrik stun effect has a shorter duration and smaller range.
* Changed so that poking blocks in build mode does more damage.
* Changed the graphical representation for Tryptanade.
* Changed so that pressing down lets go of a ladder if holding on to one.
* Changed so that Blobus screams right before detonating.
* Changed so that keyboard input is not completely reset on being zapped, and will resume when the effect wear off.
* Changed so that the sound of a player being zapped has a lower volume.
* Fixed a bug where a player spawn effect would be created at 0,0 when joining a game server running a team based mode.
* Fixed a bug that made it possible to zap teammates with the Improved Fly Zapper when friendly fire was off.
* Fixed a bug that would cause the local player to not have its own win message set.
* Fixed so that hat particles are not created on death when wearing the Trashcan powerup or a Billy.
* Fixed a bug that caused the client application to crash when revisiting the Player Setup screen after a screen resolution change.
* Fixed a bug that prevented players from killing another player with the Improved Fly Zapper.
* Fixed so that correct coordinates show up for mirrored tiles.
* Fixed a bug that would floodfill at incorrect column for mirrored tiles.
* Fixed a bug that made it possible for spawn protected players to be affected by certain negative effects.

------------------------
Alpha v0.36 [2012-10-05]
------------------------
* Added hats that are awarded to players for placing first at certain leaderboards. Bronze hats are awarded for placing first during the previous day, silver hats for placing first during the previous week and gold hats for currently being the leading player of all time (updated every 10 minutes currently).
* Added hat: Leader Tricorne (best player)
* Added hat: Dunce Cap (worst player)
* Added hat: Mining Helmet (most blocks destroyed)
* Added hat: Murderer Ushanka (most kills)
* Added hat: Capturer Cap (most F captures)
* Added hat: Emo Haircut (most suicides)
* Added 4 new music tracks by Andreas Krutholm.
* Added client settings entry: MusicPlaylistShuffle
* Added client settings entry: MusicPlaylistLoop
* Added client command: /nexttrack (plays the next music track in the playlist)
* Added client command: /prevtrack (plays the previous music track in the playlist)
* Added client command: /shuffletracks (shuffles the playlist)
* Added client command: /listtrack (shows playlist)
* Added effect for local player spawning.
* Added additional pages for player skins if needed.
* Changed so that music is not specified by maps and users now have the ability to set up their own playlist in the settings menu. All valid .ogg files found in the AppData/Music directory will be availible, with the exception of files starting with an underscore.
* Changed so that player win messages are no longer stored locally.
* Changed start ammo for Improved Fly Zapper from 8 to 6.
* Changed Improved Fly Zapper stun time from 5 to 3 seconds.
* Changed death effects a a bit for the better.
* Fixed a bug where players would keep running when being zapped while under the Tryptanade influence.
* Fixed so that all sound instances are always properly destroyed upon quitting to the game lobby.
* Fixed a bug where a timer would be incorrectly reset when a burning player got hit by additional flames.
* Fixed a bug with ESC not working properly when returning from a game.
* Fixed a bug related to kicking and banning that could lead to crashes.
* Fixed a bug that could make carried blocks become invalid when picking up new blocks.
* Fixed a bug where sounds attached to players could keep playing after they left.
* Fixed a bug where the client application could crash when a player was killed by a drain effect owned by a player who had quit.

------------------------
Alpha v0.35 [2012-09-20]
------------------------
* Added masterserverside storage for skins and win messages which should open up for some cool functionality in the future, both in game and on the website.
* Added weapon: Improved Fly Zapper (a short range and low damage weapon that stuns your opponents, rendering them unable to move)
* Added item: Infroom (fiery mushroom that creates a large cloud of fire on impact, setting those unfortunate enough to be nearby ablaze)
* Added powerup: Trashcan (reduces damage taken by 75%)
* Added map: Mount Icy Top
* Added map: CTF Empire
* Added map: Solid Gold
* Added undo and redo functionality for tile drawing in the editor. (Ctrl + Z and Ctrl + Y respectively)
* Added editor settings entry: UndoRedoSteps (default = 16)
* Added impairment of aim when under the influence of a Tryptanade.
* Added special sound effect for stomping blocks with Golden Boots.
* Changed so that blocks carried does not disappear on death but are dropped.
* Changed so that Blobus texture has a face.
* Changed color of Tryptanade.
* Fixed so that pressing ESC from Player Setup or Player Stats screen will not disconnect from the lobby.
* Fixed a bug that made it possible to jump while taking off with Infernus.
* Fixed some typos in the game server application.
* Fixed so that it is not possible to use skins that have a file size of over 50 kB.
* Fixed so that it is no longer possible to enter the Player Setup screen when not connected to the master server.

------------------------
Alpha v0.34 [2012-08-30]
------------------------
* Added full Mac OS X build of the game.
* Added visual effect to indicate that someone is under the influence of a Tryptanade and vertical movement is no longer reversed.
* Added the ability to draw tiles and objects/spawners at both sides of the map simultaneously by holding LCtrl while editing a map in the editor.
* Added activation of win face (1 second) when a player gets a kill.
* Changed so that the flood fill algorithm is much faster in the editor.
* Changed so that the area outside of the map is shown in black when working with maps smaller than the screen size in the editor.
* Fixed so that certain fragment shaders won't fail to compile on some video cards.
* Fixed so that players can only be effected by Teleporbs while spawned.
* Fixed so that players who teleport can't be climbing in mid-air when teleporting from ladders or ceilings.
* Fixed so that stomp trail effects are properly destroyed when teleporting.
* Fixed a bug where a Blobus that was stuck to the player could be attracted.

------------------------
Alpha v0.33 [2012-08-14]
------------------------
* Changed so that game servers can always offer all avaliable content (no more "demo servers") and added a free play limit of 3 hours.
* Changed so that players won't have to wait for pinging to finish before entering the player stats screen (will abort the pinging procedure).
* Fixed so that maps that don't contain appropriate player spawners can not be added to the map list of game servers.

------------------------
Alpha v0.32 [2012-08-01]
------------------------
* Added item: Blobus (bouncing ball that sticks to players)
* Added item: Teleporb (teleports user to position of impact, switching player positions when hitting another player)
* Added item: Tryptanade (creates a mind altering cloud on impact, confusing players nearby for a short period of time)
* Added shadow to the "Next map will be..." text shown between rounds in the client software to make it more noticeable over bright backgrounds.
* Fixed so that server won't be able to use maps that has missing tilesets or background images.
* Fixed a bug where stomp trail effect would act strange when a player died while stomping.
* Fixed screen flickering/lagging problem happening between rounds and when transitioning to/from main menu while playing the game in full screen mode on some video cards.
* Fixed a bug where incorrect text would sometimes show up for the Golden Boot award.
* Fixed a bug where players would crash at the player stats screen when trying to enter it while not properly connected to the master server.
* Fixed a bug where grenades would not be destroyed when too far outside of the map.
* Fixed Valkondis jittery behaviour on placement.

------------------------
Alpha v0.31 [2012-07-24]
------------------------
* Added saving of crash dumps for Windows client, editor and game server.
* Added server admin command: /shutdown
* Added case insensitivity for server- and in-game commands.
* Added server name to "roundinfo" and "listplayers" printouts in the server application.
* Added IP address of players to "listplayers" printout.
* Added printout of server name on game server startup.
* Added display of connected players and servers in the game lobby.
* Added display of how many game servers are left to refresh in the game lobby.
* Added more blood (to death effects).
* Added ability to hold LMB to scroll up/down in server window in the game lobby.
* Added ability to start login attempt using the RETURN key.
* Added color coding of ping on the scoreboard.
* Added text displaying blocks carried and current block health while in build mode.
* Added ability to pick up destroyed block by left clicking on them while in build mode.
* Added new sprites for attract and deflect.
* Added an unique sound effect for attract.
* Added ability to hide demo servers in the game lobby.
* Changed a lot of things relating to communication between master server and game servers, and there should be less problems with timeouts now. The procedure of connecting to a game server is also more rapid now.
* Changed so that crouching down looks better.
* Changed so that some death effects look better.
* Changed so that is no longer possible to send empty chat messages in the game lobby.
* Changed so that there is not possible to send chat messages or enter player stats screen while pinging game servers (to avoid certain problems).
* Changed so that pressing the refresh button in the game lobby while already refreshing halts the refresh procedure.
* Changed so that client will only try to reconnect to the master server 3 times before returning to main menu.
* Changed so that player quack sounds are not purely random but also depend on the players current health.
* Changed so that pressing ESC while in the game lobby does not exit the game but rather just exits to main menu.
* Changed default value of TilePlacementReach to 128 (was 64)
* Changed so that player power up spawners are visible on demo servers, but grayed out.
* Changed so that a weapon/item spawner containing only full version weapons/items will be reset to spawn any demo weapon/item on load.
* Fixed a bug where the game would freeze up or that the screen would flicker when players were joining while playing the game in full screen mode (Nvidia GPU:s).
* Fixed a bug where players changing team while holding the F would drop the wrong F.
* Fixed so that spawn protection glass particles are spawned at correct locations while climbing/crouching.
* Fixed vertical alignment of "Press E to respawn." message for all resolutions.
* Fixed a bug where player setup and player stats screens could become hidden from view.
* Fixed a bug where some buttons could be pressed in the game lobby while it was hidden from view.

------------------------
Alpha v0.30 [2012-07-03]
------------------------
* Added weapon: Der Rüssel (a railgun)
* Added ability to use arbitrary ports for game servers.
* Added options to automatically take screenshots on certain events. (see Settings/ClientSettings.cfg)
* Added saving of last Direct Connect address.
* Added support for connecting to hostnames through Direct Connect.
* Added splash effect in CTF for when joining the game and changing team.
* Added CTF objects to the scoreboard as well as indication of whether they are taken or not.
* Changed so that player spawn sound is not played for spawning of the local player.
* Changed texture filtering for some menu textures for a smoother look.
* Changed so that entire scoreboard is opaque.
* Fixed a bug that made the editor crash when loading maps with spaces in the filename.
* Fixed a bug where players would not be drawn when partially outside of map.
* Fixed so that Señor Bombus is rolling as intended when thrown while crouching.
* Fixed so that the player look direction is not changed by moving around.
* Fixed a connection related bug involving returning to lobby and getting an "incorrect password" message.
* Fixed so that player wings will not flap to other players while climbing ceilings.
* Fixed a bug where both "Deathmatch" and "Capture the F" would be displayed when starting a DM round.

------------------------
Alpha v0.29 [2012-06-18]
------------------------
* Added game mode: Capture the F
* Added powerup: Rapid Fire (lowers reload time)
* Added powerup: Golden Boots (higher jumps and harder stomps)
* Added leaderboard: "The Best" (based on a top secret formula)
* Added leaderboard: "Captures"
* Added server name and score limit to the scoreboard.
* Added the ability to hold LCTRL to activate build mode.
* Changed so that players with equal amount of kills are sorted by deaths (inversely) on the scoreboard.
* Fixed so that tabs are not accepted as text input.
* Fixed a bug where there would be button hover sound effects outside of view in main menu.
* Fixed a bug where players could get stuck in walls while wearing Wings of Flight.
* Fixed a bug where player arms would sometimes look odd while climbing ceilings.
* Fixed a bug where stats of newly received game servers would be corrupt before refreshing in lobby.
* Fixed a bug where players could respawn between rounds.

------------------------
Alpha v0.28 [2012-06-02]
------------------------
* Added powerups: Permashield, Quadruple Damage, Imperceptibility and Wings of Flight.
* Added weapon: Infernus (a rocket)
* Added command: /maplist
* Added command: /mapvote [filename]
* Added command: /kickvote [playername]
* Added command: /vote
* Added award: Golden Boot Award (most stomp kills)
* Added gravity and friction modifiers in the map editor.
* Added effects for when players, weapons and other items spawn.
* Added SPACE as a bindable key.
* Added a sound effect for when players are hit by Besco slugs.
* Changed Musklo so that it has higher amount of starting ammo, has shorter reload time and higher rate of fire.
* Changed Señor Bombus so that it rolls on the ground and is attractable.
* Changed Splitter so that it has lower inertia.
* Changed hitboxes for crouching players so that they are more correct.
* Changed so that kick notifications are shown in the console rather than in the game chat.
* Changed some menu graphics.
* Fixed so that no more annoying "lost connection" messages appear in the game server console.
* Fixed a bug where grenade timers would not reset correctly on deflect.
* Fixed so that game server names are unique and may not have trailing whitespaces.
* Fixed a bug that made full servers unpingable.
* Fixed a bug where long win messages would be cut off when restarting the game.
* Fixed Team Deathmatch spawners.
* Fixed a problem with the death effect when dying from deadly tiles.
* Fixed so that no unnecessary texture data is loaded for the map editor.
* Fixed a bug where regular user input would not be disabled when typing team messages.
* Fixed a bug where the health draining effect of Musklo could cause game servers to crash.

------------------------
Alpha v0.27 [2012-05-18]
------------------------
* Added ping indicator functionality to the game lobby.
* Reintroduced direct connect functionality in the game lobby.
* Moved map name to info box to give more room for server name in the game lobby.
* Lobby and in-game chat now support messages spanning multiple lines.
* Camper Model 101 has a new animation, new sounds, does more damage and can no longer be fired from behind walls.
* Holding LSHIFT in the Editor now displays tile coords for the tile at the mouse cursor.
* Projectile hitboxes are no longer problematic directly after firing a weapon.
* The detonation timer of Señor Bombus no longer restarts on deflect.
* Blood no longer travels at strange velocities under certain circumstances.
* Player spawners are no longer selected at random in TDM.
* Projectiles and other items received on connect should no longer act strange at times.
* Fixed text alignment in file overwrite dialog.
* Decreased framerate for some animations.
* In-game kick/ban functionality now works correctly.

------------------------
Alpha v0.26 [2012-05-12]
------------------------
* Added tracking of player statistics and daily/weekly/all-time leaderboards.
* Added weapon: Camper Model 101 (a powerful and precise sniper rifle)
* Added item: Señor Bombus (a devastating timed bomb that makes an annoying sound as it ticks)
* Added maps: PiranhArena & Dock Arena
* Added music track: Amara by TRD
* Most projectile types now have health and may penetrate multiple blocks before being destroyed.
* TAB can now be used to switch between edit boxes.
* HUD does no longer cover the bottom play area when player is at the lower end of a map.
* It is no longer possible to fire long barreled weapons from behind walls.
* Stomp trail effect now looks better.
* Tweaked the look of some hit and death effects.
* Out of Awesome Sauce "quack sounds" are now heard by other players in the vicinity of the quacker.
* Health draining effect of Musklo now gives the attacker Awesome Sauce.
* Tuned collision detection for Valkondis.
* Various other weapon tweaks.
* Players will no longer fire weapon when pressing arrow buttons in the game chat window.
* Deflecting no longer crashes game servers under certain conditions.
* Missing tilesets no longer leads to players crashing.
* Received background sprites now displays correctly right away.
* Icon of Coolness no longer sometimes shows next to the name of local Demo Version players in the lobby.
* Selected server index can no longer become invalid when a game server is removed in the game lobby.
* Survival Award now works correctly.
* Fixed a bug where players could crash.
* Empty entries will no longer show up in the list of players currently in the game lobby.
* HUD now updates correctly on player death.
* Color of game chat entries may no longer become invalid when rejoining a game.

------------------------
Alpha v0.25 [2012-04-19]
------------------------
* Mostly bug fixes.

------------------------
Alpha v0.24 [2012-04-18]
------------------------
* Added ability to pick up and build with destructible tiles. Build Mode is enabled with 'C', selecting between tiles is done with 'Z' and 'X' and tiles are placed and destroyed by pressing LMB in Build Mode. Set it up in the host menu in the client software or manually set the MovableTiles/TilePlacementReach variables in ServerSettings.cfg. (Full Version only)
* Added weapon: Musklo (a manly weapon that shoots health-draining flies). Be sure to enable full version items for your server in Host Menu/ServerSettings.cfg. (Full Version only)
* Added two new awards: Construction Award & Survival Award.
* Blood particles created when players are hit are now similar to those used in death effects (sticky!).
* HUD has been revamped and player chat is now in the bottom of the screen. Players can also change their current face in the hud and the face currently selected when sending a chat message will be associated with that message.
* Added team chat.
* Added an image of a skull to the scoreboard that indicates that a player is currently dead (not spawned).
* Time Left is now shown at the scoreboard for games with a time limit.
* Fixed a bug where blood would be created at (0,0)
* Multikill messages now have priority over spree messages.
* No chat message is posted when a new player enters the lobby to keep the chat window more clean.
* Friendly fire setting in the host menu should now work as intended.
* Fixed a bug where death effects would have messed up velocities when a player died climbing.
* Fixed a bug where deflected grenades owned by team mates were the wrong color.
* The sound of a player starting to regenerate health is now heard by other players.
* HUD is no longer being shown at the exit screen.
* Lines in the host menu are now thinner to make room for more settings.
* Suicides and team kills will no longer decrement the team score.
* Weapon animation does no longer reset to the first frame on ammo pickup (unless the player was out of ammo).
* Weapon recoil is now halved while crouching.
* Stomp damage raised from 20 to 35.
* The sound of lightning balls hitting a player should now have correct position.
* Added the option to remap most of the keys used in KFY. An emergency fix of sorts for people with AZERTY-keyboards so it's not changeable in the client yet but can be changed in ClientSettings.cfg.
* Fixed a bug where players could rejoin the team that they were already in.

------------------------
Alpha v0.23 [2012-04-04]
------------------------
* Added a launcher and a patcher to make updating the game less of a hassle.
* Fixed a bug where deflect explosions could cause both game servers and clients to crash in TDM.
* Fixed a bug where suicides would show up as team-kills in TDM.

------------------------
Alpha v0.22 [2012-04-01]
------------------------
* Mostly bug fixes.

------------------------
Alpha v0.21 [2012-03-31]
------------------------
* Various bug fixes.

------------------------
Alpha v0.20 [2012-03-31]
------------------------
* New game mode: Team Deathmatch (Full Version only)
* Support for huge maps (998001 tiles!) (Full Version only)
* Player limit raised to 16 (Full Version only)
* Some weapons now show a different (non-zero) animation frame when out of ammo.
* The player hitbox for map interaction is now thinner in order to get through narrow passages easier.
* Fixed a bug where the background gradient surface would not be resized on resolution change in the editor.
* Fixed a bug where players were drawn at incorrect positions.
* Fixed a bug where long player names would crash game servers.
* Fixed a bug where the awards screen would look messed up when an award winning player quit between rounds.

------------------------
Alpha v0.19 [2012-03-22]
------------------------
* Login functionality has been implemented in the client software and the menus have been redesigned a bit.
* Several changes to how maps are handled and drawn which will allow for very large maps later on, among other things.
* Added the ability to have layers of sprites behind the map. Currently there are two ground layers that are aligned with the bottom of the map, tile, scroll at different speeds and have fully customizable graphics (the game server will send out the image files if need be).
* Added the ability to have a second background color for maps. A gradient is formed with these two colors ranging from the top of the map to the bottom.
* Players are now asked if they would like to overwrite files when connecting to a server that is using files that are different than those of the connecting player. Answering no will disconnect the player from the server.
* Raised maximum number of characters in username to 16.
* Raised maximum number of characters in win message to 28.
* Added 2 new songs made by Pär Carlsson.
* Changed appearance of Billy to reveal more of the player wearing it.
* Besco has once again been nerfed and has had its reload time raised and maximum ammo value lowered.
* Slightly improved effects for explosions.
* Added better culling methods for certain objects.
* The Skillful Murderer award now works as intended.
* Map layers can now be toggled on and off in the editor and the layers button is more intuitive in its appearance.
* Server admins can now change the rate at which player position updates are sent out at. Set to 30 ms by default.
* Fixed a bug where the scoreboard would look strange if an award winning player had left the game prior to the round ending.
* Fixed a bug where the game would freeze for players joining between rounds.
* Fixed a bug where players would fall slowly when going below the bottom of the map.
* Most user input is now activated while viewing the scoreboard.

------------------------
Alpha v0.18 [2012-03-07]
------------------------
* Added seven different awards that players can be given at the end of the round.
* Added the ability for server admins to kick players from the scoreboard.
* The name of the next map in the map list is now shown between rounds.
* Removed dimension limit on map sizes but added a limit on the total number of tiles (currently 25600).
* Fixed several bugs that could cause the client and server to crash.
* Splash screen can now be skipped even when music is turned off.
* Lowered sound volume on some songs.
* Toggling music on/off in the menu now works as intended.
* Fixed a bug where particles would interact with non-solid tiles in the middle map layer.
* It is no longer possible to pick up grenades/weapons while typing.
* No more trailing junk characters while viewing the changelog in the client on Linux and Mac OS X.
* Kick/ban commands are now also avaliable in the server app and the duration of a ban can now also be set.

------------------------
Alpha v0.17 [2012-03-02]
------------------------
* Linux and Mac OS X builds are now avaliable.
* Weapon added: Magnum (a big gun)
* Grenade added: Deflectonade (exactly what it sounds like)
* Added a new music track for the menu. (made by Pär Carlsson)
* Added deadly tiles.
* Fixed a bug where the game would sometimes crash on startup.
* Map dimensions are now clamped between 1 and 200 in the editor.
* Map dimensions are now displayed when loading maps in the editor.
* The load menu of the editor is now updated when coming back from editing a map.
* Fixed a bug where the hitbox for Valkondis (mine) would be way off.
* Billy has slightly higher damage and do more reasonable damage to tiles.
* Various changes to the map format and how maps are handled
* Added culling for particle systems to increase performance.
* Added pixel perfect collision detection for blood/gib particles.
* The /suicide command now works as it should.

------------------------
Alpha v0.16 [2012-02-22]
------------------------
* Destructible tiles are now actually destructible and flash red when hit (unless destroyed). The health assigned to these tiles is multiplied by 4 (and thus the minimum amount of damage needed to be able to harm a tile is 4).
* Added visuals and audio for reaching certain numbers (3, 5, 10, 20) of consecutive kills.
* Added bullet (and anything else for that matter) proof glass that protects a recently spawned player for 3 seconds. It is removed if a player picks up a weapon/grenade, deflects, attracts or stomps.
* Changed the music tracks that are played between rounds. The new ones are made by Pär Carlsson.
* Game servers can now have admin passwords assigned to them which can be used by server admins to login (by typing /login [password] in the game chat) and send certain commands to the game server.
* Game servers can now be password protected. (not to be confused with the admin password mentioned above)
* Server administrators can kick and ban people by using the command "/kick [playername] [reason]" and "/ban [playername] [reason]".
* Added a command ("/suicide") to let players who are stuck and such to die and respawn at a valid spawn point. To avoid that this feature us abused, it has a 5 second timer associated with it.
* Fixed a bug where all dead players would see the message "You fell off the map!" when another player did.
* White spaces are no longer allowed in player names.
* Fixed bug where "Warning: Trying to fetch unknown weapon." would be printed repetedly.
* The vector for initial velocity of projectiles now originate from the center of the player.
* Fixed a bug where some variables used when starting a new game would not be loaded from disk properly.
* Particles created on player death will no longer be able to be created inside solid tiles.
* The hitbox for crouching players is now correct.
* A players face will no longer change while typing a chat message using the 1-6 keys.
* Added sounds for when a player tries to attract/deflect but has no sauce.
* Death effects for crouching players should now look more correct.
* Added a new visual effect for when stomping another player.
* Added some new stuff to the game splash screen.
* Players are now notified that they get disconnected from the lobby when initiating a connection attempt.
* Added audio and face change for when a player starts to regenerate health.
* It is no longer possible to grab ladders while crouching under ceilings.
* Valkondis has had its damage lowered.
* The damage and ejection speed of splitters have been increased.
* Deflect explosions now have lower damage.
* Number of besco slugs fired with one shot lowered from 16 to 12.
* Timed grenades have their timer reset when they are deflected.
* Splitter grenades (the small ones) will inherit the deflect charge from the grenade they are ejected from.

------------------------
Alpha v0.15 [2012-02-17]
------------------------
* Chat box is now properly cleared when re-entering the lobby.
* It is no longer possible to enter an empty name in player setup.
* Resolution will be set to 800x600 if an invalid resolution is specified in ClientSettings.cfg.
* Max Players will be set to 1 or 8 if a value outside of that range is specified in ClientSettings.cfg.
* If no name is found in ClientSettings.cfg on game start, name will be set to "NoName".
* It should no longer be possible to be stood up by weapon recoil or explosions while crouching below tiles.
* Full game servers should no longer time out from the lobby.
* The correct number of players should now be sent to clients in lobby when a game server is (re-)registered.
* Names will no longer be rejected by game servers but rather changed to become valid.
* An option to hide empty and/or full game servers is now avaliable in the lobby.
* Fixed a bug where the YES button in the quit dialog could be pressed repeatedly.
* Double clicking on game servers in lobby now works as indended.
* Added a simple splash screen.

------------------------
Alpha v0.14 [2012-02-16]
------------------------
* The communication between the game servers and the lobby server is now more stable.
* Cooldown (500 ms) on deflects now works.
* Fixed some problems with deflect explosions.
* Fixed a bug where grenade velocities would be clamped too low.
* Slightly increased blast radius of deflect explosions.
* Fixed a bug where the incorrect cartoon image would be displayed when returning to main menu from the lobby.
* Time is now displayed correctly in the lobby.
* Tileset data received over the network is now being loaded properly.
* The hitbox for the largest lightning gun projectile has been made a bit smaller.

------------------------
Alpha v0.13 [2012-02-15]
------------------------
* Deflect charge should now work as intended with grenades.
* Players can now connect to a game server by double clicking on it in the lobby.
* Lowered the minimum time between connection attempts.
* Improved collision detection for grenades.
* All particle systems (such as the stomp trail) bound to a player are now properly destroyed on player death.
* Dead stompers can no longer do any harm.
* Explosions can no longer make players reach speeds high enough to go through walls.
* Grenades are now affected by explosions.
* Added the option to snap the mouse cursor to the game area when playing in windowed mode. On by default. See the Settings menu.
* It is no longer possible to enter the lobby while trying to connect to a game.
* All grenade have had their blast force and damage increased.
* Various improvements of the lobby system, including the ability to chat with other players in the lobby, direct notification of servers starting and closing, and much more frequent updates to the list of game servers.
* Valkondis is no longer attractable and has had its hit box shortened so that it can be placed close to walls without acting strange.
* Fixed a bug where players were unable to stomp when standing too close to a wall.
* Weapon hotspot for Billy lowered while climbing ceilings.
* Players can now fire continuously while typing.
* It is no longer possible to fire weapons, attract or deflect between rounds.
* Damage of Billy Rockets lowered.
* Besco Slugs are now slightly larger and slower.
* Fixed a bug where horizontal velocity of a player was not reset when hitting a wall at low speeds.
* Explonades are now slightly more heavy and are thrown with increased force.
* Player stats are now hard coded (used to be loaded from ServerSettings.cfg).
* Death effects should not look a bit better.
* Trying to start the game with an invalid player skins in /UserData/Skins will no longer give a cryptic assertation exit but rather just print an error message.
* Added 500ms cooldown to deflect
* When a splitter detonates the small grenades are now ejected at smaller angles than before.
* Multikill messages!
* Added an effect (visual+audio) to make it more clear when you kill someone.
* Fixed a bug where player could respawn instantaneously by holding 'E' while dying.
* Player skins are now drawn on top of an opaque rectangle to prevent players from creating skins that make the body of the player invisible.
* Added an about screen containing the KFY changelog as well as the game credits.
* Slightly toned down the fragment shader used to draw the lobby so it can run better (at all) on some low end cards.
* Scaled down some text on the scoreboard to be able to fit names of the maximum length (currently 12 characters).
* Fixed a bug where the vertical velocity of Billy Rockets would be clamped way too low.
* Grenades and projectiles drawn on top of the players.
* Player should not be able to be seen briefly on their death pos before respawning anymore.
* Fixed bug where player could click on a button of a menu when it was off the screen.

------------------------
Alpha v0.12 [2012-02-11]
------------------------
* Implemented a lobby system to find internet games, including simple sorting of game servers and a way of finding your friends (or enemies :)).
* Player names with >12 characters and win messages with >22 characters are no longer possible.

------------------------
Alpha v0.11 [2012-02-07]
------------------------
* Added a new kind of particle effects to make player death more visually entertaining.
* Added a sound effect for player death.
* Fixed a bug where positive x-components of velocities would be clamped to a smaller value than negative ones.
* Player movement will now slow down only when the player is not actively moving (with A or D), making it possible to run faster using weapon recoil.
* Corrected the sound played when Lightning Balls hit walls.
* Added visual and auditory indications for when Besco slugs hit walls.
* The "Spawn All" check box in the editor should now be working as intended.
* Background color of a level is now loaded correctly on map change.
* Overhaul of the interface of the editor software to make it more visually pleasing and easier to work with.
* New values for server settings.
* Projectiles are now being hidden by default when a wall collision is detected locally.
* Deflect charge is now slightly more visually apparent.
* Grenades are now affected by deflect and attract.
* Fixed where player could invoke deflect/attract between rounds.
* Fixed a bug where only the first 7 skins loaded would be displayed in the player setup screen.
* Some changes to the scoreboard to make it more visually pleasing.
* Fixed where no skin would be selected when the last used skin had been removed since the last launch of the game client.
* Changed how skins are handled. Skins of remote players live only in main memory now and are never saved to disk.
* The winner of the round now have its "Win Message" displayed between rounds.
* The same message (belonging to the killing player) is also displayed to a killed player, unless the player killed itself.
* Fixed a bug where a player would still be crouching on respawn if its died while crouching.
* FPS and other debug info is now only shown if debug mode is enabled (see ClientSettings.cfg).
* Added a 2 second delay before a player is able to respawn after death.
* All projectiles and grenades are now sent to a joining player.
* Valkondis (a mine) implemented.
* Stomp can only be invoked when >32 pixels (2 tiles) above ground.
* Trying out a way of intepolating player positions. Toggle with F2. (on by default)
* Rearranged the order in which different things are drawn.
* Besco slugs are now slower and do 4 damage (was 2).
* Billy tweaked. Less blast damage and radius.
* Added the KFY logo to the main menu.
* Small splitters are now heavier and ejected with an increased speed.
* Input is no longer processed by the console module while a GUI textbox control has focus.
* A server can no longer be started from the client if no maps are in the map list.

------------------------
Alpha v0.10 [2012-01-30]
------------------------
* Score- and time limit must now be non-zero when starting a server from the client software (they will be clamped to 1 if not set or set to zero)
* Fixed a crash where message boxes couldn't be displayed in the editor.
* The client can now handle maps of an arbitrary size, as they are now split up into 1024x1024 pixel textures, as opposed to one single texture for the entire map.
  Map size handled by the client is still currently limited by the amount of avaliable VRAM, but if using very big maps seems very attractive,
  this could later be fixed by swapping textures to main memory. There are however other problems with really big maps
  (such as having to send a lot of map data to clients between rounds).
  Map sizes in the editor are still limited by the maximum texture size of the GPU used for now.
* "sticky" particle systems (blood) removed for now because of various issues with them, but they may be back in future releases.
* Players now start with 50 Awesome Sauce points.
* HP regeneration is now three times as fast.
* Name of local player is no longer displayed in game.
* Player stats changed.
* Setting max players is now implemented in the server software.
* Fixed a bug where the client would stop responding when joining a newly started server.
* Music now plays between rounds.
* Map Shuffle is now implemented in the server software.
* WASD movement is now disabled while typing in edit boxes in the editor.
* Object are now placed on a grid in the editor by default (different grids for different objects). Hold shift to place freely.
* Players now look in the direction of the mouse cursor.
* Maximum fall speed increased, and thus also the speed of stomps.
* It should no longer be possible to go through walls after being hit by a powerful explosion.
* Players bounce against walls only if having a speed higher than the maximum run speed.
* Besco now has slightly more recoil.
* Billy has been tweaked (weapon hotspot moved upwards, projectile hotspot moved to middle, air resistance, heavier projectiles, increased initial velocity etc)
* Map is now scrolled more smoothly in the client software.
* Lightning Gun implemented.
* Trail effect for stomp now aligned correctly height-wise.
* Deflects are now active for 333 ms.
* Deflect charge more visually apparent on projectiles.
* Grenades are now thrown with a fixed velocity.
* Explonade timer changed from 3 to 2 seconds.
* Splitter (grenade) implemented.
* Markers for sound- and music volume now have correct positions in the settings menu.
* Billy Rockets now explode at a more correct position when colliding with the map.
* Music tracks can now be specified in maps and these should be handled correcly by all of the applications.
